import { object, string, boolean } from '@edtr-io/plugin';
import { PrimarySettings, EditorInput, EditorCheckbox } from '@edtr-io/editor-ui';
import { styled } from '@edtr-io/ui';
import { useState, createElement, Fragment } from 'react';
import { PrismAsyncLight } from 'react-syntax-highlighter';
import style from 'react-syntax-highlighter/dist/cjs/styles/prism/coy';

var Textarea =
/*#__PURE__*/
styled.textarea({
  height: '250px',
  width: '100%',
  margin: 'auto',
  padding: '10px',
  resize: 'none',
  fontFamily: 'Menlo, Monaco, "Courier New", monospace',
  border: 'none',
  outline: 'none',
  boxShadow: '0 1px 1px 0 rgba(0,0,0,0.50)',
  '&::-webkit-input-placeholder': {
    color: 'rgba(0,0,0,0.5)'
  }
});
var CheckboxContainer =
/*#__PURE__*/
styled.div({
  "float": 'right'
});
function HighlightEditor(props) {
  var config = props.config,
      state = props.state,
      focused = props.focused,
      editable = props.editable;
  var Renderer = config.Renderer;
  var edit = focused && editable;

  var _React$useState = useState(edit),
      throttledEdit = _React$useState[0],
      setEditThrottled = _React$useState[1];

  if (edit != throttledEdit) {
    if (!edit) {
      setTimeout(function () {
        setEditThrottled(false);
      }, 500);
    } else {
      setEditThrottled(true);
    }
  }

  return throttledEdit || edit ? createElement(Fragment, null, createElement(Textarea, {
    value: state.code.value,
    name: "text",
    placeholder: "F\xFCge hier deinen Code ein. Verlasse den Bereich, um eine Vorschau zu sehen.",
    onChange: function onChange(e) {
      state.code.set(e.target.value);
    }
  }, state.code.value), createElement(PrimarySettings, null, createElement(EditorInput, {
    list: "available-languages",
    label: "Language:",
    value: state.language.value,
    onChange: function onChange(e) {
      state.language.set(e.target.value);
    },
    placeholder: "enter Language"
  }), createElement("datalist", {
    id: "available-languages"
  }, ['c', 'javascript', 'jsx', 'markup', 'java', 'python'].map(function (language, index) {
    return createElement("option", {
      key: index,
      value: language
    });
  })), createElement(CheckboxContainer, null, createElement(EditorCheckbox, {
    label: "Zeilennummern anzeigen",
    onChange: function onChange() {
      state.showLineNumbers.set(!state.showLineNumbers.value);
    },
    checked: state.showLineNumbers.value
  })))) : createElement(Renderer, {
    language: state.language.value,
    showLineNumbers: state.showLineNumbers.value,
    code: state.code.value
  });
}

function HighlightRenderer(props) {
  return createElement(PrismAsyncLight, {
    language: props.language,
    showLineNumbers: props.showLineNumbers,
    style: style,
    customStyle: {
      overflow: 'auto'
    }
  }, props.code || 'Klicke hier und füg deinen Quellcode ein...');
}

/** @public */

var highlightState =
/*#__PURE__*/
object({
  code:
  /*#__PURE__*/
  string(''),
  language:
  /*#__PURE__*/
  string('text'),
  showLineNumbers:
  /*#__PURE__*/
  boolean(false)
});
/**
 * @param config - {@link HighlightConfig | Plugin configuration}
 * @public
 */

function createHighlightPlugin(config) {
  if (config === void 0) {
    config = {
      Renderer: HighlightRenderer
    };
  }

  return {
    Component: HighlightEditor,
    config: config,
    state: highlightState
  };
}

export { createHighlightPlugin, highlightState };
//# sourceMappingURL=plugin-highlight.esm.js.map
